import java.awt.*;
import java.io.*;
import java.lang.*;

/***********************************************************
 * PhField Class<br>
 *   ̂^Ԃ\NX<br>
 *   RunCanvas Class p<br>
 ***********************************************************/
abstract class PhField extends RunCanvas {
  /** ԊԊu  **/
  double dt;
  /** zu镨̂̌  **/
  int n;
  /** ̂̔z  **/
  PhObject[] obj;

  /** lݒ@̂̌kŎw **/
  abstract void init(int k);

  /** ͂ݒ  **/
  abstract void set_force();

  /** ̃NXKvȌ  **/
  public void makeObject(int k){
    int i;
    
    n = k;
    obj = new PhObject[k];
    for (i=0; i < n; i++){
      obj[i] = new PhObject();
    }
  }


  /** ̂`   **/
  public void drawCanvas(ExGraphics gr){
    int i;
    gr.setColor(Color.blue);
    for (i=0; i<n; i++){
      obj[i].drawShape(gr, getSize());
    }
  }
  
  /** ̂   **/
  public void eraseCanvas(ExGraphics gr){
    int i;
    gr.setColor(getBackground());
    for (i=0; i<n; i++){
      obj[i].drawShape(gr, getSize());
    }
  }
  
  /** Ԍoߎ̏I[o[Ch   **/
  public void pastTime() {
    int i;
    set_force();
    for (i=0; i<n; i++){
      obj[i].a.set_acc( obj[i].get_f(), obj[i].get_m());
      obj[i].v.add_vel( obj[i].get_a(), dt);
      obj[i].s.add_pos( obj[i].get_v(), dt);
    }
  }



}

