import java.awt.*;
import java.io.*;
import java.lang.*;

/************************************************************
 * PhObject Class<BR>
 *  ͊ŵ\NX<BR>
 ************************************************************/
public class PhObject {
  /**  ̂̈ʒu   **/
  Position s = new Position();
  /**  ̂̑x   **/
  Velocity v = new Velocity();
  /**  ̂̉x  **/
  Acceleration a = new Acceleration();
  /**  ̂ɂ͂炭  **/
  Force f = new Force();
  /**  ̂̎  **/
  double m;
  /**  ̂̓dC  **/
  double q;

  /**  Ԍoߎ̏  **/
  public void past_time( Force f, double dt) {
    a.set_acc( f, m);
    v.add_vel( a, dt);
    s.add_pos( v, dt);
  }

  /** ʂݒ **/
  public void set_m( double m1){
    m = m1;
  }

  /** ʒu擾 **/
  public Position get_s() {
    return s;
  }

  /** x擾 **/
  public Velocity get_v() {
    return v;
  }

  /** x擾 **/
  public Acceleration get_a() {
    return a;
  }

  /** ͂擾 **/
  public Force get_f() {
    return f;
  }

  /** ʂ擾 **/
  public double get_m() {
    return m;
  }

  /** ̂` **/
  public void drawShape( ExGraphics gr, Dimension rect){
    gr.fillCircle( (int)(s.getx()), (int)(rect.height - s.gety()), 5);
  }
}  


/**  xxNgNX **/
class Velocity extends Vect{

  /**  xw肵ĔԌoߌ̑xvZ  **/
  public void add_vel(Acceleration a, double dt){
    double vx, vy, ax, ay;
    Vect v = new Vect();
    
    v.set(scl, angle);
    v.set(v.v_add(a.v_times(dt)));
    scl = v.getscl();
    angle = v.getangle();
  }
}

/**  xNX  **/
class Acceleration extends Vect{
  public void set_acc( Force f, double m) {
    scl =  f.getscl() / m;
    angle = f.getangle();
  }
}

/**  ̓xNgNX  **/
class Force extends Vect{

}

/**  ʒuxNgNX  **/
class Position {
  /** xW  **/
  double x;
  /** yW  **/
  double y;
  
  /**  ʒuݒ  **/
  public void set( Position p){
    x = p.getx();
    y = p.gety();
  }
  /**  (x,y)Wňʒuݒ  **/
  public void set( double x1, double y1){
    x = x1;
    y = y1;
  }
  
  /**  xW擾  **/
  public double getx(){
    return x;
  }
  
  /**  yW擾  **/
  public double gety(){
    return y;
  }
  
  /**  x^ĔԌoߌ̈ʒuvZ  **/
  public void add_pos(Velocity v, double dt){
    double vx, vy;

    vx = v.getscl() * Math.cos( v.getangle());
    vy = v.getscl() * Math.sin( v.getangle());

    x = x + vx * dt;
    y = y + vy * dt;
  }

  /**  _܂ł̋擾  **/
  public double dist( Position p) {
    return Math.sqrt(
     ( x - p.getx())*( x - p.getx()) + ( y - p.gety()) * ( y - p.gety()));
  }

  /**  _̌擾  **/
  public double direct( Position p) {
    return Math.atan2( p.gety() - y, p.getx() - x);
  }  
}

